Project Chrono: chrono::vehicle::ChGenericWheeledSuspension Class Reference

Classes | Public Member Functions | Protected Member Functions | List of all members
chrono::vehicle::ChGenericWheeledSuspension Class Referenceabstract
VEHICLE module » Wheeled vehicles » Suspension subsystem

## Description

Base class for a generic wheeled vehicle suspension.

Except for the spindle bodies and the associated revolute joints, the topology of such a suspension is completely arbitrary and left to derived classes. Derived from ChSuspension, but still an abstract base class.

The suspension subsystem is modeled with respect to a right-handed frame, with X pointing towards the front, Y to the left, and Z up (ISO standard). The suspension reference frame is assumed to be always aligned with that of the vehicle. When attached to a chassis, only an offset is provided.

All point locations are assumed to be given for the left half of the suspension and will be mirrored (reflecting the y coordinates) to construct the right side.

`#include <ChGenericWheeledSuspension.h>`

Inheritance diagram for chrono::vehicle::ChGenericWheeledSuspension:
[legend]
Collaboration diagram for chrono::vehicle::ChGenericWheeledSuspension:
[legend]

## Classes
struct | BodyIdentifier
| Identification of a body in the suspension subsystem. More...
struct | ChassisIdentifier
| Identification of the vehicle chassis body. More...
struct | SubchassisIdentifier
| Identification of a vehicle subchassis body. More...
struct | SteeringIdentifier
| Identification of a vehicle steering link body. More...

## Public Member Functions
virtual std::string | GetTemplateName () const override
| Get the name of the vehicle subsystem template.
void | DefineBody (const std::string &name, bool mirrored, const ChVector3d &pos, const ChQuaternion<> &rot, double mass, const ChVector3d &inertia_moments, const ChVector3d &inertia_products, std::shared_ptr< ChVehicleGeometry > geometry=nullptr)
| Add a body definition to the suspension subsystem.
void | DefineJoint (const std::string &name, bool mirrored, ChVehicleJoint::Type type, BodyIdentifier body1, BodyIdentifier body2, const ChVector3d &pos, const ChQuaternion<> &rot, std::shared_ptr< ChVehicleBushingData > bdata=nullptr)
| Add a joint definition to the suspension subsystem.
void | DefineDistanceConstraint (const std::string &name, bool mirrored, BodyIdentifier body1, BodyIdentifier body2, const ChVector3d &point1, const ChVector3d &point2)
| Add a distance constraint definition to the suspension subsystem.
void | DefineTSDA (const std::string &name, bool mirrored, BodyIdentifier body1, BodyIdentifier body2, const ChVector3d &point1, const ChVector3d &point2, double rest_length, std::shared_ptr< ChLinkTSDA::ForceFunctor > force, std::shared_ptr< ChTSDAGeometry > geometry=nullptr)
| Add a TSDA to model a suspension spring or shock.
void | DefineRSDA (const std::string &name, bool mirrored, BodyIdentifier body1, BodyIdentifier body2, const ChVector3d &pos, const ChVector3d &axis, double rest_angle, std::shared_ptr< ChLinkRSDA::TorqueFunctor > torque)
| Add an RSDA to model a suspension spring or shock.
virtual void | Initialize (std::shared_ptr< ChChassis > chassis, std::shared_ptr< ChSubchassis > subchassis, std::shared_ptr< ChSteering > steering, const ChVector3d &location, double left_ang_vel=0, double right_ang_vel=0) override
| Initialize this suspension subsystem.
virtual void | AddVisualizationAssets (VisualizationType vis) override
| Add visualization assets for the suspension subsystem.
virtual void | RemoveVisualizationAssets () override
| Remove visualization assets for the suspension subsystem.
virtual double | GetTrack () override
| Get the wheel track for the suspension subsystem.
virtual std::vector< ForceTSDA > | ReportSuspensionForce (VehicleSide side) const override
| Return current suspension TSDA force information on the specified side.
virtual std::vector< ForceRSDA > | ReportSuspensionTorque (VehicleSide side) const override
| Return current RSDA torque information on the specified side.
virtual void | LogConstraintViolations (VehicleSide side) override
| Log current constraint violations.
virtual std::shared_ptr< ChBody > | GetAntirollBody (VehicleSide side) const override
| Specify the suspension body on the specified side to attach a possible antirollbar subsystem.
Public Member Functions inherited from chrono::vehicle::ChSuspension
virtual bool | IsSteerable () const =0
| Specify whether or not this suspension can be steered.
virtual bool | IsIndependent () const =0
| Specify whether or not this is an independent suspension.
const ChVector3d & | GetRelPosition () const
| Get the location of the suspension subsystem relative to the associated chassis reference frame.
std::shared_ptr< ChBody > | GetSpindle (VehicleSide side) const
| Get a handle to the spindle body on the specified side.
std::shared_ptr< ChShaft > | GetAxle (VehicleSide side) const
| Get a handle to the axle shaft on the specified side.
std::shared_ptr< ChLinkLockRevolute > | GetRevolute (VehicleSide side) const
| Get a handle to the revolute joint on the specified side.
const ChVector3d & | GetSpindlePos (VehicleSide side) const
| Get the global location of the spindle on the specified side.
ChQuaternion | GetSpindleRot (VehicleSide side) const
| Get the orientation of the spindle body on the specified side.
const ChVector3d & | GetSpindleLinVel (VehicleSide side) const
| Get the linear velocity of the spindle body on the specified side.
ChVector3d | GetSpindleAngVel (VehicleSide side) const
| Get the angular velocity of the spindle body on the specified side.
double | GetAxleSpeed (VehicleSide side) const
| Get the angular speed of the axle on the specified side.
virtual void | Synchronize (double time)
| Synchronize this suspension subsystem.
virtual void | Advance (double step)
| Advance the state of the suspension subsystem by the specified time step.
void | ApplyAxleTorque (VehicleSide side, double torque)
| Apply the provided motor torque.
virtual double | getSpindleRadius () const =0
| Return the radius of the spindle body (visualization only).
virtual double | getSpindleWidth () const =0
| Return the width of the spindle body (visualization only).
virtual std::shared_ptr< ChBody > | GetBrakeBody (VehicleSide side) const
| Specify the body on the specified side for a possible connection to brake subsystem.
void | ApplyParkingBrake (bool brake)
| Simple model of a parking brake.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
virtual void | SetOutput (bool state)
| Enable/disable output for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.

## Protected Member Functions
| ChGenericWheeledSuspension (const std::string &name)
| Protected constructor.
virtual double | getCamberAngle () const
| Return the camber angle, in radians (default: 0).
virtual double | getToeAngle () const
| Return the toe angle, in radians (default: 0).
virtual ChVector3d | getSpindlePos () const =0
| Return the location of the spindle body.
virtual double | getSpindleMass () const =0
| Return the mass of the spindle body.
virtual const ChVector3d & | getSpindleInertia () const =0
| Return the moments of inertia of the spindle body.
virtual BodyIdentifier | getSpindleAttachmentBody () const =0
| Specify the suspension body to which the spindle is attached.
virtual double | getAxleInertia () const =0
| Return the inertia of the axle shaft.
virtual BodyIdentifier | getAntirollBody () const =0
| Specify the suspension body to which an antiroll bar subsystem can attach.
Protected Member Functions inherited from chrono::vehicle::ChSuspension
| ChSuspension (const std::string &name)
| Construct a suspension subsystem with given name.
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
virtual void | Create (const rapidjson::Document &d)
| Create a vehicle subsystem from JSON data.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).
Protected Attributes inherited from chrono::vehicle::ChSuspension
ChVector3d | m_rel_loc
| location relative to chassis
std::shared_ptr< ChBody > | m_spindle [2]
| handles to spindle bodies
std::shared_ptr< ChShaft > | m_axle [2]
| handles to axle shafts
std::shared_ptr< ChShaftBodyRotation > | m_axle_to_spindle [2]
| handles to spindle-shaft connectors
std::shared_ptr< ChLinkLockRevolute > | m_revolute [2]
| handles to spindle revolute joints
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Member Function Documentation

## ◆ AddVisualizationAssets()

void chrono::vehicle::ChGenericWheeledSuspension::AddVisualizationAssets | ( | VisualizationType | vis | ) |
| overridevirtual

Add visualization assets for the suspension subsystem.

This default implementation uses primitives.

Reimplemented from chrono::vehicle::ChSuspension.

## ◆ DefineBody()

void chrono::vehicle::ChGenericWheeledSuspension::DefineBody | ( | const std::string & | name,
|  | bool | mirrored,
|  | const ChVector3d & | pos,
|  | const ChQuaternion<> & | rot,
|  | double | mass,
|  | const ChVector3d & | inertia_moments,
|  | const ChVector3d & | inertia_products,
|  | std::shared_ptr< ChVehicleGeometry > | geometry = nullptr )

Add a body definition to the suspension subsystem.

Parameters

  name | body name
  mirrored | true if mirrored on right side
  pos | body COM position (in subsystem reference frame)
  rot | body frame orientation (in subsystem reference frame)
  mass | body mass
  inertia_moments | body moments of inertia (relative to COG frame)
  inertia_products | body products of inertia (relative to COG frame)
  geometry | optional collision and visualization geometry

## ◆ DefineDistanceConstraint()

void chrono::vehicle::ChGenericWheeledSuspension::DefineDistanceConstraint | ( | const std::string & | name,
|  | bool | mirrored,
|  | BodyIdentifier | body1,
|  | BodyIdentifier | body2,
|  | const ChVector3d & | point1,
|  | const ChVector3d & | point2 )

Add a distance constraint definition to the suspension subsystem.

Parameters

  name | constraint name
  mirrored | true if mirrored on right side
  body1 | first connected body
  body2 | second connected body
  point1 | point on body1 (in subsystem reference frame)
  point2 | point on body2 (in subsystem reference frame)

## ◆ DefineJoint()

void chrono::vehicle::ChGenericWheeledSuspension::DefineJoint | ( | const std::string & | name,
|  | bool | mirrored,
|  | ChVehicleJoint::Type | type,
|  | BodyIdentifier | body1,
|  | BodyIdentifier | body2,
|  | const ChVector3d & | pos,
|  | const ChQuaternion<> & | rot,
|  | std::shared_ptr< ChVehicleBushingData > | bdata = nullptr )

Add a joint definition to the suspension subsystem.

If bushing data is provided, creates a bushing. Otherwise, creates a kinematic joint.

Parameters

  name | joint name
  mirrored | true if mirrored on right side
  type | joint type
  body1 | first connected body
  body2 | second connected body
  pos | joint position (in subsystem reference frame)
  rot | joint frame orientation (in subsystem reference frame)
  bdata | optional bushing data

## ◆ DefineRSDA()

void chrono::vehicle::ChGenericWheeledSuspension::DefineRSDA | ( | const std::string & | name,
|  | bool | mirrored,
|  | BodyIdentifier | body1,
|  | BodyIdentifier | body2,
|  | const ChVector3d & | pos,
|  | const ChVector3d & | axis,
|  | double | rest_angle,
|  | std::shared_ptr< ChLinkRSDA::TorqueFunctor > | torque )

Add an RSDA to model a suspension spring or shock.

Parameters

  name | RSDA name
  mirrored | true if mirrored on right side
  body1 | first connected body
  body2 | second connected body
  pos | RSDA position (in subsystem reference frame)
  axis | axis of action for the RSDA
  rest_angle | rest (free) angle
  torque | functor for RSDA torque evaluation

## ◆ DefineTSDA()

void chrono::vehicle::ChGenericWheeledSuspension::DefineTSDA | ( | const std::string & | name,
|  | bool | mirrored,
|  | BodyIdentifier | body1,
|  | BodyIdentifier | body2,
|  | const ChVector3d & | point1,
|  | const ChVector3d & | point2,
|  | double | rest_length,
|  | std::shared_ptr< ChLinkTSDA::ForceFunctor > | force,
|  | std::shared_ptr< ChTSDAGeometry > | geometry = nullptr )

Add a TSDA to model a suspension spring or shock.

Parameters

  name | TSDA name
  mirrored | true if mirrored on right side
  body1 | first connected body
  body2 | second connected body
  point1 | point on body1 (in subsystem reference frame)
  point2 | point on body2 (in subsystem reference frame)
  rest_length | rest (free) length
  force | functor for TSDA force evaluation
  geometry | optional visualization geometry

## ◆ GetAntirollBody()

std::shared_ptr< ChBody > chrono::vehicle::ChGenericWheeledSuspension::GetAntirollBody | ( | VehicleSide | side | ) | const
| overridevirtual

Specify the suspension body on the specified side to attach a possible antirollbar subsystem.

Return the corresponding lower control arm.

Reimplemented from chrono::vehicle::ChSuspension.

## ◆ getAntirollBody()

virtual BodyIdentifier chrono::vehicle::ChGenericWheeledSuspension::getAntirollBody | ( |  | ) | const
| protectedpure virtual

Specify the suspension body to which an antiroll bar subsystem can attach.

Implemented in chrono::vehicle::GenericWheeledSuspension.

## ◆ getAxleInertia()

virtual double chrono::vehicle::ChGenericWheeledSuspension::getAxleInertia | ( |  | ) | const
| protectedpure virtual

Return the inertia of the axle shaft.

Implemented in chrono::vehicle::GenericWheeledSuspension.

## ◆ getCamberAngle()

virtual double chrono::vehicle::ChGenericWheeledSuspension::getCamberAngle | ( |  | ) | const
| inlineprotectedvirtual

Return the camber angle, in radians (default: 0).

Reimplemented in chrono::vehicle::GenericWheeledSuspension.

## ◆ getSpindleAttachmentBody()

virtual BodyIdentifier chrono::vehicle::ChGenericWheeledSuspension::getSpindleAttachmentBody | ( |  | ) | const
| protectedpure virtual

Specify the suspension body to which the spindle is attached.

Implemented in chrono::vehicle::GenericWheeledSuspension.

## ◆ getSpindleInertia()

virtual const ChVector3d & chrono::vehicle::ChGenericWheeledSuspension::getSpindleInertia | ( |  | ) | const
| protectedpure virtual

Return the moments of inertia of the spindle body.

Implemented in chrono::vehicle::GenericWheeledSuspension.

## ◆ getSpindleMass()

virtual double chrono::vehicle::ChGenericWheeledSuspension::getSpindleMass | ( |  | ) | const
| protectedpure virtual

Return the mass of the spindle body.

Implemented in chrono::vehicle::GenericWheeledSuspension.

## ◆ getSpindlePos()

virtual ChVector3d chrono::vehicle::ChGenericWheeledSuspension::getSpindlePos | ( |  | ) | const
| protectedpure virtual

Return the location of the spindle body.

Implemented in chrono::vehicle::GenericWheeledSuspension.

## ◆ GetTemplateName()

virtual std::string chrono::vehicle::ChGenericWheeledSuspension::GetTemplateName | ( |  | ) | const
| inlineoverridevirtual

Get the name of the vehicle subsystem template.

Implements chrono::vehicle::ChPart.

## ◆ getToeAngle()

virtual double chrono::vehicle::ChGenericWheeledSuspension::getToeAngle | ( |  | ) | const
| inlineprotectedvirtual

Return the toe angle, in radians (default: 0).

A positive value indicates toe-in, a negative value indicates toe-out.

Reimplemented in chrono::vehicle::GenericWheeledSuspension.

## ◆ GetTrack()

double chrono::vehicle::ChGenericWheeledSuspension::GetTrack | ( |  | ) |
| overridevirtual

Get the wheel track for the suspension subsystem.

Implements chrono::vehicle::ChSuspension.

## ◆ Initialize()

void chrono::vehicle::ChGenericWheeledSuspension::Initialize | ( | std::shared_ptr< ChChassis > | chassis,
|  | std::shared_ptr< ChSubchassis > | subchassis,
|  | std::shared_ptr< ChSteering > | steering,
|  | const ChVector3d & | location,
|  | double | left_ang_vel = 0,
|  | double | right_ang_vel = 0 )
| overridevirtual

Initialize this suspension subsystem.

The suspension subsystem is initialized by attaching it to the specified chassis and (if provided) to the specified subchassis, at the specified location (with respect to and expressed in the reference frame of the chassis). It is assumed that the suspension reference frame is always aligned with the chassis reference frame.

Parameters

  chassis | associated chassis subsystem
  subchassis | associated subchassis subsystem (may be null)
  steering | associated steering subsystem (may be null)
  location | location relative to the chassis frame
  left_ang_vel | initial angular velocity of left wheel
  right_ang_vel | initial angular velocity of right wheel

Reimplemented from chrono::vehicle::ChSuspension.

## ◆ LogConstraintViolations()

void chrono::vehicle::ChGenericWheeledSuspension::LogConstraintViolations | ( | VehicleSide | side | ) |
| overridevirtual

Log current constraint violations.

Reimplemented from chrono::vehicle::ChSuspension.

## ◆ RemoveVisualizationAssets()

void chrono::vehicle::ChGenericWheeledSuspension::RemoveVisualizationAssets | ( |  | ) |
| overridevirtual

Remove visualization assets for the suspension subsystem.

Reimplemented from chrono::vehicle::ChSuspension.

## ◆ ReportSuspensionForce()

std::vector< ChSuspension::ForceTSDA > chrono::vehicle::ChGenericWheeledSuspension::ReportSuspensionForce | ( | VehicleSide | side | ) | const
| overridevirtual

Return current suspension TSDA force information on the specified side.

Reimplemented from chrono::vehicle::ChSuspension.

## ◆ ReportSuspensionTorque()

std::vector< ChSuspension::ForceRSDA > chrono::vehicle::ChGenericWheeledSuspension::ReportSuspensionTorque | ( | VehicleSide | side | ) | const
| overridevirtual

Return current RSDA torque information on the specified side.

Reimplemented from chrono::vehicle::ChSuspension.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/wheeled_vehicle/suspension/ChGenericWheeledSuspension.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/wheeled_vehicle/suspension/ChGenericWheeledSuspension.cpp